include $(TOPDIR)/rules.mk
-include $(STAGING_DIR)/components.config

PKG_NAME:=libswu
PKG_VERSION:=v0.5.7
SHORT_DESCRIPTION:=Library to hide board-specific aspects related to SW upgrade

PKG_SOURCE_PROTO:=git
PKG_SOURCE_VERSION:=v0.5.7
PKG_SOURCE_URL:=https://$(SAH_GIT_USER):$(SAH_GIT_TOKEN)@$(SAH_GIT)/$(SAH_GIT_GROUP)/libswu.git
PKG_MIRROR_HASH:=skip
PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
PKG_MAINTAINER:=Soft At Home <support.opensource@softathome.com>
PKG_LICENSE:=BSD-2-Clause-Patent
PKG_LICENSE_FILES:=LICENSE


PKG_RELEASE:=1

include $(INCLUDE_DIR)/package.mk

define Package/$(PKG_NAME)
  CATEGORY:=SoftAtHome
  SUBMENU:=Libraries
  TITLE:=$(SHORT_DESCRIPTION)
  DEPENDS += +PRPL_BUILD:libubootenv
  DEPENDS += +PRPL_BUILD:zlib
  DEPENDS += +libsahtrace
  DEPENDS += +SAH_KERNEL_BROADCOM_4_19:kernel
  MENU:=1
endef

define Package/$(PKG_NAME)/description
	Library to hide board-specific aspects related to SW upgrade
endef

define Build/Compile
	$(call Build/Compile/Default, STAGINGDIR=$(STAGING_DIR) CONFIGDIR=$(STAGING_DIR) PKG_CONFIG_PATH=$(STAGING_DIR)/usr/lib/pkgconfig LIBDIR=/usr/lib INSTALL_LIB_DIR=/lib INSTALL_BIN_DIR=/bin RAW_VERSION=$(PKG_VERSION) HARDCO_HAL_DIR=$(STAGING_DIR)/usr/include CONFIG_SAH_LIB_SWU_STORAGE_TYPE=$(CONFIG_SAH_LIB_SWU_STORAGE_TYPE) CONFIG_SAH_LIB_SWU_UBI_DEVICE_NUMBER=$(CONFIG_SAH_LIB_SWU_UBI_DEVICE_NUMBER) CONFIG_SAH_LIB_SWU_TOOLS=$(CONFIG_SAH_LIB_SWU_TOOLS) CONFIG_SAH_LIB_SWU_PREVIOUS_STAGE_NAME=$(CONFIG_SAH_LIB_SWU_PREVIOUS_STAGE_NAME) CONFIG_SAH_LIB_SWU_SWUPDATE_PUBKEY=$(CONFIG_SAH_LIB_SWU_SWUPDATE_PUBKEY) CONFIG_SAH_LIB_SWU_SWUPDATE_MIN_VERSION=$(CONFIG_SAH_LIB_SWU_SWUPDATE_MIN_VERSION) CONFIG_SAH_LIB_SWU_DUAL_BANK_SCHEME=$(CONFIG_SAH_LIB_SWU_DUAL_BANK_SCHEME) CONFIG_SAH_LIB_SWU_FLASH_LAYOUT_FORMAT=$(CONFIG_SAH_LIB_SWU_FLASH_LAYOUT_FORMAT))
endef

define Build/Install
	$(call Build/Install/Default, install INSTALL=install D=$(PKG_INSTALL_DIR) DEST=$(PKG_INSTALL_DIR) STAGINGDIR=$(STAGING_DIR) CONFIGDIR=$(STAGING_DIR) PV=$(PKG_VERSION) PKG_CONFIG_LIBDIR=$(STAGING_DIR)/usr/lib/pkgconfig LIBDIR=/usr/lib INSTALL_LIB_DIR=/lib INSTALL_BIN_DIR=/bin RAW_VERSION=$(PKG_VERSION) HARDCO_HAL_DIR=$(STAGING_DIR)/usr/include CONFIG_SAH_LIB_SWU_STORAGE_TYPE=$(CONFIG_SAH_LIB_SWU_STORAGE_TYPE) CONFIG_SAH_LIB_SWU_UBI_DEVICE_NUMBER=$(CONFIG_SAH_LIB_SWU_UBI_DEVICE_NUMBER) CONFIG_SAH_LIB_SWU_TOOLS=$(CONFIG_SAH_LIB_SWU_TOOLS) CONFIG_SAH_LIB_SWU_PREVIOUS_STAGE_NAME=$(CONFIG_SAH_LIB_SWU_PREVIOUS_STAGE_NAME) CONFIG_SAH_LIB_SWU_SWUPDATE_PUBKEY=$(CONFIG_SAH_LIB_SWU_SWUPDATE_PUBKEY) CONFIG_SAH_LIB_SWU_SWUPDATE_MIN_VERSION=$(CONFIG_SAH_LIB_SWU_SWUPDATE_MIN_VERSION) CONFIG_SAH_LIB_SWU_DUAL_BANK_SCHEME=$(CONFIG_SAH_LIB_SWU_DUAL_BANK_SCHEME) CONFIG_SAH_LIB_SWU_FLASH_LAYOUT_FORMAT=$(CONFIG_SAH_LIB_SWU_FLASH_LAYOUT_FORMAT))
endef

define Build/InstallDev
	$(call Build/Install/Default, install INSTALL=install D=$(STAGING_DIR) DEST=$(STAGING_DIR) STAGINGDIR=$(STAGING_DIR) CONFIGDIR=$(STAGING_DIR) PV=$(PKG_VERSION) PKG_CONFIG_LIBDIR=$(STAGING_DIR)/usr/lib/pkgconfig LIBDIR=/usr/lib INSTALL_LIB_DIR=/lib INSTALL_BIN_DIR=/bin RAW_VERSION=$(PKG_VERSION) HARDCO_HAL_DIR=$(STAGING_DIR)/usr/include CONFIG_SAH_LIB_SWU_STORAGE_TYPE=$(CONFIG_SAH_LIB_SWU_STORAGE_TYPE) CONFIG_SAH_LIB_SWU_UBI_DEVICE_NUMBER=$(CONFIG_SAH_LIB_SWU_UBI_DEVICE_NUMBER) CONFIG_SAH_LIB_SWU_TOOLS=$(CONFIG_SAH_LIB_SWU_TOOLS) CONFIG_SAH_LIB_SWU_PREVIOUS_STAGE_NAME=$(CONFIG_SAH_LIB_SWU_PREVIOUS_STAGE_NAME) CONFIG_SAH_LIB_SWU_SWUPDATE_PUBKEY=$(CONFIG_SAH_LIB_SWU_SWUPDATE_PUBKEY) CONFIG_SAH_LIB_SWU_SWUPDATE_MIN_VERSION=$(CONFIG_SAH_LIB_SWU_SWUPDATE_MIN_VERSION) CONFIG_SAH_LIB_SWU_DUAL_BANK_SCHEME=$(CONFIG_SAH_LIB_SWU_DUAL_BANK_SCHEME) CONFIG_SAH_LIB_SWU_FLASH_LAYOUT_FORMAT=$(CONFIG_SAH_LIB_SWU_FLASH_LAYOUT_FORMAT))
endef

define Package/$(PKG_NAME)/install
	$(CP) $(PKG_INSTALL_DIR)/* $(1)/
	if [ -d ./files ]; then \
		$(CP) ./files/* $(1)/; \
	fi
	find $(1) -name *.a -exec rm {} +;
	find $(1) -name *.h -exec rm {} +;
	find $(1) -name *.pc -exec rm {} +;
endef

define Package/$(PKG_NAME)/config
	source "$(SOURCE)/Config.in"
endef

$(eval $(call BuildPackage,$(PKG_NAME)))
